function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["onClick", "loading", "originLoading", "children", "stop", "noPadding", "className", "debounceWait", "icon", "iconColor", "type"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useRef, forwardRef } from 'react';
import { Button } from 'antd';
import { PREFIX_CLS } from "../constants/dictionary";
import { LoadingOutlined } from '@ant-design/icons';
import debounce from 'lodash.debounce';
import classnames from 'classnames';
import "./style/index.less";
var needFocusColor = ['default', 'dashed', 'ghost'];
var prefixCls = "".concat(PREFIX_CLS, "-button");
var AntdButton = /*#__PURE__*/forwardRef(function (props, ref) {
  var onClick = props.onClick,
    loading = props.loading,
    originLoading = props.originLoading,
    children = props.children,
    _props$stop = props.stop,
    stop = _props$stop === void 0 ? true : _props$stop,
    _props$noPadding = props.noPadding,
    noPadding = _props$noPadding === void 0 ? false : _props$noPadding,
    className = props.className,
    _props$debounceWait = props.debounceWait,
    debounceWait = _props$debounceWait === void 0 ? 300 : _props$debounceWait,
    icon = props.icon,
    iconColor = props.iconColor,
    type = props.type,
    restProps = _objectWithoutProperties(props, _excluded);
  var oisRef = useRef(debounce(function (fn, e) {
    fn === null || fn === void 0 || fn(e);
  }, debounceWait, {
    leading: true,
    trailing: false
  }));
  var handleClick = function handleClick(e) {
    if (stop) {
      e.stopPropagation();
    }
    if (loading) return;
    if (debounceWait) {
      var _oisRef$current;
      onClick && ((_oisRef$current = oisRef.current) === null || _oisRef$current === void 0 ? void 0 : _oisRef$current.call(oisRef, onClick, e));
    } else {
      onClick === null || onClick === void 0 || onClick(e); // 0 => 关闭防抖
    }
  };
  return /*#__PURE__*/React.createElement(Button, _extends({
    ref: ref
  }, restProps, {
    loading: originLoading // 改变原本的loading
    ,
    className: classnames(className, "".concat(prefixCls), _defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-noPadding"), noPadding), "".concat(prefixCls, "-loadingStatus"), loading), "".concat(prefixCls, "-iconHoverColor"), !!iconColor && needFocusColor.includes(type || ''))),
    icon: icon && /*#__PURE__*/React.createElement("span", {
      style: {
        color: iconColor
      }
    }, icon),
    onClick: handleClick,
    type: type
  }), children, loading && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-loadingStatus-loading")
  }, /*#__PURE__*/React.createElement(LoadingOutlined, null)));
});
AntdButton.Group = Button.Group;
export default AntdButton;