/// <reference types="react" />
import type { ButtonProps as AntdButtonProps } from 'antd';
import { Button } from 'antd';
export interface ButtonProps extends AntdButtonProps {
    /** 通过设置debounceWait进入防抖模式 默认开 */
    debounceWait?: number;
    /** 是否阻止事件冒泡，在防抖模式下特别需要 默认开 */
    stop?: boolean;
    /** 是否有padding,默认有 */
    noPadding?: boolean;
    originLoading?: boolean | {
        delay: number;
    };
    loading?: boolean;
    iconColor?: string;
}
export interface CompoundedComponent extends React.ForwardRefExoticComponent<ButtonProps & React.RefAttributes<React.Ref<HTMLElement>>> {
    Group: typeof Button.Group;
}
