var _excluded = ["open", "needActive", "onDropdownVisibleChange", "loading", "disabled", "maxTagTextLength", "size"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useState } from 'react';
import { Cascader } from 'antd';
import Icon from "../Icon";
import Tag from "../Tag";
import Typography from "../Typography";
import { LoadingOutlined } from '@ant-design/icons';
import { PREFIX_CLS, normal_text_color, disabled_text_color } from "../constants/dictionary";
import "./styles/index.less";
var LongText = Typography.LongText;
var prefixCls = "".concat(PREFIX_CLS, "-cascader");
var HEIGHT = {
  large: 30,
  middle: 24,
  small: 18
};
var AntdCascader = function AntdCascader(_ref) {
  var open = _ref.open,
    needActive = _ref.needActive,
    onDropdownVisibleChange = _ref.onDropdownVisibleChange,
    loading = _ref.loading,
    disabled = _ref.disabled,
    maxTagTextLength = _ref.maxTagTextLength,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 'middle' : _ref$size,
    restProps = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isActive = _useState2[0],
    setIsActive = _useState2[1];
  useEffect(function () {
    if (open === undefined) return;
    needActive && setIsActive(open);
  }, [open]);
  var onPreventMouseDown = function onPreventMouseDown(event) {
    event.preventDefault();
    event.stopPropagation();
  };
  var _onClick = function onClick(visiable) {
    // 这里加个判断，open是否从外部传入，如果是从外部传入的，那么走useEffect中的逻辑就行
    onDropdownVisibleChange && onDropdownVisibleChange(visiable);
    if (open !== undefined) {
      return needActive && setIsActive(open);
    }
    setIsActive(visiable);
  };
  return /*#__PURE__*/React.createElement(Cascader, _extends({
    open: isActive,
    suffixIcon: !loading ? /*#__PURE__*/React.createElement(Icon, {
      onClick: function onClick() {
        return _onClick(!isActive);
      },
      type: "downArrow",
      color: disabled ? disabled_text_color : normal_text_color,
      rotate: isActive && !disabled ? 180 : 0
    }) : /*#__PURE__*/React.createElement(LoadingOutlined, null),
    tagRender: function tagRender(item) {
      var onClose = item.onClose;
      var label = typeof item.label === 'string' ? /*#__PURE__*/React.createElement(LongText, {
        text: item.label,
        length: maxTagTextLength
      }) : item.label;
      return /*#__PURE__*/React.createElement(Tag, {
        className: "".concat(prefixCls, "-tag"),
        type: disabled ? 'disabled' : 'selected',
        height: HEIGHT[size],
        closable: !disabled,
        onClick: function onClick() {
          return needActive && setIsActive(!isActive);
        },
        onMouseDown: onPreventMouseDown,
        onClose: onClose
      }, label);
    },
    size: size,
    disabled: disabled,
    onDropdownVisibleChange: _onClick
  }, restProps));
};
AntdCascader.defaultProps = {
  clearIcon: /*#__PURE__*/React.createElement(Icon, {
    type: "closeAreality",
    size: 16
  }),
  expandIcon: /*#__PURE__*/React.createElement(Icon, {
    type: "rightArrow"
  }),
  needActive: true,
  maxTagTextLength: 4
};
export default AntdCascader;