function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/**
 * title: 方向
 * desc: 这里列出了支持 `rtl` 方向的组件，您可以在演示中切换方向。
 * slug: true
 */
import { DownloadOutlined, LeftOutlined, MinusOutlined, PlusOutlined, RightOutlined, SearchOutlined as SearchIcon, SmileOutlined } from '@ant-design/icons';
import { Space } from 'antd';
import { Badge, Button, Cascader, Col, Divider, Input, InputNumber, Modal, Pagination, Radio, Rate, Row, Select, Steps, Switch, Tree, TreeSelect } from 'antd';
import { ConfigProvider } from 'rlj-design';
import React, { useState } from 'react';
var InputGroup = Input.Group;
var ButtonGroup = Button.Group;
var Option = Select.Option;
var TreeNode = Tree.TreeNode;
var Search = Input.Search;
var cascaderOptions = [{
  value: 'tehran',
  label: 'تهران',
  children: [{
    value: 'tehran-c',
    label: 'تهران',
    children: [{
      value: 'saadat-abad',
      label: 'سعادت آیاد'
    }]
  }]
}, {
  value: 'ardabil',
  label: 'اردبیل',
  children: [{
    value: 'ardabil-c',
    label: 'اردبیل',
    children: [{
      value: 'primadar',
      label: 'پیرمادر'
    }]
  }]
}, {
  value: 'gilan',
  label: 'گیلان',
  children: [{
    value: 'rasht',
    label: 'رشت',
    children: [{
      value: 'district-3',
      label: 'منطقه ۳'
    }]
  }]
}];
var Page = function Page(_ref) {
  var popupPlacement = _ref.popupPlacement;
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    currentStep = _useState2[0],
    setCurrentStep = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    modalOpen = _useState4[0],
    setModalOpen = _useState4[1];
  var _useState5 = useState(5),
    _useState6 = _slicedToArray(_useState5, 2),
    badgeCount = _useState6[0],
    setBadgeCount = _useState6[1];
  var _useState7 = useState(true),
    _useState8 = _slicedToArray(_useState7, 2),
    showBadge = _useState8[0],
    setShowBadge = _useState8[1];
  var selectBefore = /*#__PURE__*/React.createElement(Select, {
    defaultValue: "Http://",
    style: {
      width: 90
    }
  }, /*#__PURE__*/React.createElement(Option, {
    value: "Http://"
  }, "Http://"), /*#__PURE__*/React.createElement(Option, {
    value: "Https://"
  }, "Https://"));
  var selectAfter = /*#__PURE__*/React.createElement(Select, {
    defaultValue: ".com",
    style: {
      width: 80
    }
  }, /*#__PURE__*/React.createElement(Option, {
    value: ".com"
  }, ".com"), /*#__PURE__*/React.createElement(Option, {
    value: ".jp"
  }, ".jp"), /*#__PURE__*/React.createElement(Option, {
    value: ".cn"
  }, ".cn"), /*#__PURE__*/React.createElement(Option, {
    value: ".org"
  }, ".org"));

  // ==== Cascader ====
  var cascaderFilter = function cascaderFilter(inputValue, path) {
    return path.some(function (option) {
      return option.label.toLowerCase().indexOf(inputValue.toLowerCase()) > -1;
    });
  };
  var onCascaderChange = function onCascaderChange(value) {
    console.log(value);
  };
  // ==== End Cascader ====

  // ==== Modal ====
  var showModal = function showModal() {
    setModalOpen(true);
  };
  var handleOk = function handleOk(e) {
    console.log(e);
    setModalOpen(false);
  };
  var handleCancel = function handleCancel(e) {
    console.log(e);
    setModalOpen(false);
  };

  // ==== End Modal ====

  var onStepsChange = function onStepsChange(newCurrentStep) {
    console.log('onChange:', newCurrentStep);
    setCurrentStep(newCurrentStep);
  };

  // ==== Badge ====

  var increaseBadge = function increaseBadge() {
    setBadgeCount(badgeCount + 1);
  };
  var declineBadge = function declineBadge() {
    var newBadgeCount = badgeCount - 1;
    if (newBadgeCount < 0) {
      newBadgeCount = 0;
    }
    setBadgeCount(newBadgeCount);
  };
  var onChangeBadge = function onChangeBadge(checked) {
    setShowBadge(checked);
  };
  // ==== End Badge ====

  return /*#__PURE__*/React.createElement("div", {
    className: "direction-components"
  }, /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 24
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Cascader example"), /*#__PURE__*/React.createElement(Cascader, {
    suffixIcon: /*#__PURE__*/React.createElement(SearchIcon, null),
    options: cascaderOptions,
    onChange: onCascaderChange,
    placeholder: "\u06CC\u06A9 \u0645\u0648\u0631\u062F \u0627\u0646\u062A\u062E\u0627\u0628 \u06A9\u0646\u06CC\u062F",
    popupPlacement: popupPlacement
  }), "\xA0\xA0\xA0\xA0 With search:", /*#__PURE__*/React.createElement(Cascader, {
    suffixIcon: /*#__PURE__*/React.createElement(SmileOutlined, null),
    options: cascaderOptions,
    onChange: onCascaderChange,
    placeholder: "Select an item",
    popupPlacement: popupPlacement,
    showSearch: {
      filter: cascaderFilter
    }
  }))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Switch example"), "\xA0\xA0", /*#__PURE__*/React.createElement(Switch, {
    defaultChecked: true
  }), "\xA0\xA0", /*#__PURE__*/React.createElement(Switch, {
    loading: true,
    defaultChecked: true
  }), "\xA0\xA0", /*#__PURE__*/React.createElement(Switch, {
    size: "small",
    loading: true
  })), /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Radio Group example"), /*#__PURE__*/React.createElement(Radio.Group, {
    defaultValue: "c",
    buttonStyle: "solid"
  }, /*#__PURE__*/React.createElement(Radio.Button, {
    value: "a"
  }, "\u062A\u0647\u0631\u0627\u0646"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "b",
    disabled: true
  }, "\u0627\u0635\u0641\u0647\u0627\u0646"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "c"
  }, "\u0641\u0627\u0631\u0633"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "d"
  }, "\u062E\u0648\u0632\u0633\u062A\u0627\u0646")))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Button example"), /*#__PURE__*/React.createElement(Space, {
    size: 10,
    wrap: true
  }, /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    icon: /*#__PURE__*/React.createElement(DownloadOutlined, null)
  }), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    shape: "circle",
    icon: /*#__PURE__*/React.createElement(DownloadOutlined, null)
  }), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    shape: "round",
    icon: /*#__PURE__*/React.createElement(DownloadOutlined, null)
  }), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    shape: "round",
    icon: /*#__PURE__*/React.createElement(DownloadOutlined, null)
  }, "Download"), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    icon: /*#__PURE__*/React.createElement(DownloadOutlined, null)
  }, "Download"), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Button.Group, null, /*#__PURE__*/React.createElement(Button, {
    type: "primary"
  }, /*#__PURE__*/React.createElement(LeftOutlined, null), "Backward"), /*#__PURE__*/React.createElement(Button, {
    type: "primary"
  }, "Forward", /*#__PURE__*/React.createElement(RightOutlined, null))), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    loading: true
  }, "Loading"), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    size: "small",
    loading: true
  }, "Loading"))), /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Tree example"), /*#__PURE__*/React.createElement(Tree, {
    showLine: true,
    checkable: true,
    defaultExpandedKeys: ['0-0-0', '0-0-1'],
    defaultSelectedKeys: ['0-0-0', '0-0-1'],
    defaultCheckedKeys: ['0-0-0', '0-0-1']
  }, /*#__PURE__*/React.createElement(TreeNode, {
    title: "parent 1",
    key: "0-0"
  }, /*#__PURE__*/React.createElement(TreeNode, {
    title: "parent 1-0",
    key: "0-0-0",
    disabled: true
  }, /*#__PURE__*/React.createElement(TreeNode, {
    title: "leaf",
    key: "0-0-0-0",
    disableCheckbox: true
  }), /*#__PURE__*/React.createElement(TreeNode, {
    title: "leaf",
    key: "0-0-0-1"
  })), /*#__PURE__*/React.createElement(TreeNode, {
    title: "parent 1-1",
    key: "0-0-1"
  }, /*#__PURE__*/React.createElement(TreeNode, {
    title: /*#__PURE__*/React.createElement("span", {
      style: {
        color: '#1890ff'
      }
    }, "sss"),
    key: "0-0-1-0"
  })))))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 24
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Input (Input Group) example"), /*#__PURE__*/React.createElement(InputGroup, {
    size: "large"
  }, /*#__PURE__*/React.createElement(Row, {
    gutter: 8
  }, /*#__PURE__*/React.createElement(Col, {
    span: 5
  }, /*#__PURE__*/React.createElement(Input, {
    defaultValue: "0571"
  })), /*#__PURE__*/React.createElement(Col, {
    span: 8
  }, /*#__PURE__*/React.createElement(Input, {
    defaultValue: "26888888"
  })))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(InputGroup, {
    compact: true
  }, /*#__PURE__*/React.createElement(Input, {
    style: {
      width: '20%'
    },
    defaultValue: "0571"
  }), /*#__PURE__*/React.createElement(Input, {
    style: {
      width: '30%'
    },
    defaultValue: "26888888"
  })), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(InputGroup, {
    compact: true
  }, /*#__PURE__*/React.createElement(Select, {
    defaultValue: "Option1"
  }, /*#__PURE__*/React.createElement(Option, {
    value: "Option1"
  }, "Option1"), /*#__PURE__*/React.createElement(Option, {
    value: "Option2"
  }, "Option2")), /*#__PURE__*/React.createElement(Input, {
    style: {
      width: '50%'
    },
    defaultValue: "input content"
  }), /*#__PURE__*/React.createElement(InputNumber, null)), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Search, {
    placeholder: "input search text",
    enterButton: "Search",
    size: "large"
  }), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("div", {
    style: {
      marginBottom: 16
    }
  }, /*#__PURE__*/React.createElement(Input, {
    addonBefore: selectBefore,
    addonAfter: selectAfter,
    defaultValue: "mysite"
  })), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Select example"), /*#__PURE__*/React.createElement(Space, {
    size: 10,
    wrap: true
  }, /*#__PURE__*/React.createElement(Select, {
    mode: "multiple",
    defaultValue: "\u0645\u0648\u0631\u0686\u0647",
    style: {
      width: 120
    }
  }, /*#__PURE__*/React.createElement(Option, {
    value: "jack"
  }, "Jack"), /*#__PURE__*/React.createElement(Option, {
    value: "\u0645\u0648\u0631\u0686\u0647"
  }, "\u0645\u0648\u0631\u0686\u0647"), /*#__PURE__*/React.createElement(Option, {
    value: "disabled",
    disabled: true
  }, "Disabled"), /*#__PURE__*/React.createElement(Option, {
    value: "Yiminghe"
  }, "yiminghe")), /*#__PURE__*/React.createElement(Select, {
    defaultValue: "\u0645\u0648\u0631\u0686\u0647",
    style: {
      width: 120
    },
    disabled: true
  }, /*#__PURE__*/React.createElement(Option, {
    value: "\u0645\u0648\u0631\u0686\u0647"
  }, "\u0645\u0648\u0631\u0686\u0647")), /*#__PURE__*/React.createElement(Select, {
    defaultValue: "\u0645\u0648\u0631\u0686\u0647",
    style: {
      width: 120
    },
    loading: true
  }, /*#__PURE__*/React.createElement(Option, {
    value: "\u0645\u0648\u0631\u0686\u0647"
  }, "\u0645\u0648\u0631\u0686\u0647")), /*#__PURE__*/React.createElement(Select, {
    showSearch: true,
    style: {
      width: 200
    },
    placeholder: "Select a person",
    optionFilterProp: "children",
    filterOption: function filterOption(input, option) {
      return (option === null || option === void 0 ? void 0 : option.props.children.toLowerCase().indexOf(input.toLowerCase())) >= 0;
    }
  }, /*#__PURE__*/React.createElement(Option, {
    value: "jack"
  }, "Jack"), /*#__PURE__*/React.createElement(Option, {
    value: "\u0633\u0639\u06CC\u062F"
  }, "\u0633\u0639\u06CC\u062F"), /*#__PURE__*/React.createElement(Option, {
    value: "tom"
  }, "Tom")))), /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "TreeSelect example"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(TreeSelect, {
    showSearch: true,
    style: {
      width: '100%'
    },
    dropdownStyle: {
      maxHeight: 400,
      overflow: 'auto'
    },
    placeholder: "Please select",
    allowClear: true,
    treeDefaultExpandAll: true
  }, /*#__PURE__*/React.createElement(TreeNode, {
    title: "parent 1",
    key: "0-1"
  }, /*#__PURE__*/React.createElement(TreeNode, {
    title: "parent 1-0",
    key: "0-1-1"
  }, /*#__PURE__*/React.createElement(TreeNode, {
    title: "my leaf",
    key: "random"
  }), /*#__PURE__*/React.createElement(TreeNode, {
    title: "your leaf",
    key: "random1"
  })), /*#__PURE__*/React.createElement(TreeNode, {
    title: "parent 1-1",
    key: "random2"
  }, /*#__PURE__*/React.createElement(TreeNode, {
    title: /*#__PURE__*/React.createElement("b", {
      style: {
        color: '#08c'
      }
    }, "sss"),
    key: "random3"
  }))))))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 24
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Modal example"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    onClick: showModal
  }, "Open Modal"), /*#__PURE__*/React.createElement(Modal, {
    title: "\u067E\u0646\u0686\u0631\u0647 \u0633\u0627\u062F\u0647",
    open: modalOpen,
    onOk: handleOk,
    onCancel: handleCancel
  }, /*#__PURE__*/React.createElement("p", null, "\u0646\u06AF\u0627\u0634\u062A\u0647\u200C\u0647\u0627\u06CC \u062E\u0648\u062F \u0631\u0627 \u0627\u06CC\u0646\u062C\u0627 \u0642\u0631\u0627\u0631\u062F\u0647\u06CC\u062F"), /*#__PURE__*/React.createElement("p", null, "\u0646\u06AF\u0627\u0634\u062A\u0647\u200C\u0647\u0627\u06CC \u062E\u0648\u062F \u0631\u0627 \u0627\u06CC\u0646\u062C\u0627 \u0642\u0631\u0627\u0631\u062F\u0647\u06CC\u062F"), /*#__PURE__*/React.createElement("p", null, "\u0646\u06AF\u0627\u0634\u062A\u0647\u200C\u0647\u0627\u06CC \u062E\u0648\u062F \u0631\u0627 \u0627\u06CC\u0646\u062C\u0627 \u0642\u0631\u0627\u0631\u062F\u0647\u06CC\u062F"))))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 24
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Steps example"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Steps, {
    progressDot: true,
    current: currentStep,
    items: [{
      title: 'Finished',
      description: 'This is a description.'
    }, {
      title: 'In Progress',
      description: 'This is a description.'
    }, {
      title: 'Waiting',
      description: 'This is a description.'
    }]
  }), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Steps, {
    current: currentStep,
    onChange: onStepsChange,
    items: [{
      title: 'Step 1',
      description: 'This is a description.'
    }, {
      title: 'Step 2',
      description: 'This is a description.'
    }, {
      title: 'Step 3',
      description: 'This is a description.'
    }]
  })))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Rate example"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Rate, {
    defaultValue: 2.5
  }), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("strong", null, "* Note:"), " Half star not implemented in RTL direction, it will be supported after ", /*#__PURE__*/React.createElement("a", {
    href: "https://github.com/react-component/rate"
  }, "rc-rate"), ' ', "implement rtl support.")), /*#__PURE__*/React.createElement(Col, {
    span: 12
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Badge example"), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Badge, {
    count: badgeCount
  }, /*#__PURE__*/React.createElement("a", {
    href: "#",
    className: "head-example"
  })), /*#__PURE__*/React.createElement(ButtonGroup, null, /*#__PURE__*/React.createElement(Button, {
    onClick: declineBadge
  }, /*#__PURE__*/React.createElement(MinusOutlined, null)), /*#__PURE__*/React.createElement(Button, {
    onClick: increaseBadge
  }, /*#__PURE__*/React.createElement(PlusOutlined, null)))), /*#__PURE__*/React.createElement("div", {
    style: {
      marginTop: 10
    }
  }, /*#__PURE__*/React.createElement(Badge, {
    dot: showBadge
  }, /*#__PURE__*/React.createElement("a", {
    href: "#",
    className: "head-example"
  })), /*#__PURE__*/React.createElement(Switch, {
    onChange: onChangeBadge,
    checked: showBadge
  }))))))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 24
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Pagination example"), /*#__PURE__*/React.createElement(Pagination, {
    showSizeChanger: true,
    defaultCurrent: 3,
    total: 500
  }))), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 24
  }, /*#__PURE__*/React.createElement(Divider, {
    orientation: "left"
  }, "Grid System example"), /*#__PURE__*/React.createElement("div", {
    className: "grid-demo"
  }, /*#__PURE__*/React.createElement("div", {
    className: "code-box-demo"
  }, /*#__PURE__*/React.createElement("p", null, /*#__PURE__*/React.createElement("strong", null, "* Note:"), " Every calculation in RTL grid system is from right side (offset, push, etc.)"), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 8
  }, "col-8"), /*#__PURE__*/React.createElement(Col, {
    span: 8,
    offset: 8
  }, "col-8")), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 6,
    offset: 6
  }, "col-6 col-offset-6"), /*#__PURE__*/React.createElement(Col, {
    span: 6,
    offset: 6
  }, "col-6 col-offset-6")), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 12,
    offset: 6
  }, "col-12 col-offset-6")), /*#__PURE__*/React.createElement(Row, null, /*#__PURE__*/React.createElement(Col, {
    span: 18,
    push: 6
  }, "col-18 col-push-6"), /*#__PURE__*/React.createElement(Col, {
    span: 6,
    pull: 18
  }, "col-6 col-pull-18")))))));
};
var App = function App() {
  var _useState9 = useState('ltr'),
    _useState10 = _slicedToArray(_useState9, 2),
    direction = _useState10[0],
    setDirection = _useState10[1];
  var _useState11 = useState('bottomLeft'),
    _useState12 = _slicedToArray(_useState11, 2),
    popupPlacement = _useState12[0],
    setPopupPlacement = _useState12[1];
  var changeDirection = function changeDirection(e) {
    var directionValue = e.target.value;
    setDirection(directionValue);
    if (directionValue === 'rtl') {
      setPopupPlacement('bottomRight');
    } else {
      setPopupPlacement('bottomLeft');
    }
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    style: {
      marginBottom: 16
    }
  }, /*#__PURE__*/React.createElement("span", {
    style: {
      marginRight: 16
    }
  }, "Change direction of components: "), /*#__PURE__*/React.createElement(Radio.Group, {
    defaultValue: "ltr",
    onChange: changeDirection
  }, /*#__PURE__*/React.createElement(Radio.Button, {
    key: "ltr",
    value: "ltr"
  }, "LTR"), /*#__PURE__*/React.createElement(Radio.Button, {
    key: "rtl",
    value: "rtl"
  }, "RTL"))), /*#__PURE__*/React.createElement(ConfigProvider, {
    direction: direction
  }, /*#__PURE__*/React.createElement(Page, {
    popupPlacement: popupPlacement
  })));
};
export default App;