var _excluded = ["allowClear", "disabled", "onChange", "value", "defaultValue"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useState } from 'react';
import { DatePicker } from 'antd';
import RangePicker from "./RangePicker";
import { PREFIX_CLS, normal_text_color } from "../constants/dictionary";
import moment from 'moment';
import Icon from "../Icon";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-datePicker");
export var clearIconHandle = function clearIconHandle(allowClear) {
  return typeof allowClear === 'boolean' ? allowClear && /*#__PURE__*/React.createElement(Icon, {
    type: "closeAreality",
    size: 16
  }) : allowClear !== null && allowClear !== void 0 && allowClear.clearIcon ? allowClear === null || allowClear === void 0 ? void 0 : allowClear.clearIcon : false;
};
var NORMAL_ICON_COLOR = normal_text_color;
var AntdDatePicker = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$allowClear = props.allowClear,
    allowClear = _props$allowClear === void 0 ? true : _props$allowClear,
    disabled = props.disabled,
    onChange = props.onChange,
    value = props.value,
    defaultValue = props.defaultValue,
    restProps = _objectWithoutProperties(props, _excluded);
  var _useState = useState(defaultValue ? moment(defaultValue) : undefined),
    _useState2 = _slicedToArray(_useState, 2),
    realValue = _useState2[0],
    setRealValue = _useState2[1];
  useEffect(function () {
    if (value) {
      setRealValue(moment(value));
    }
  }, [value]);
  var customizeOnChange = function customizeOnChange(e, datastring) {
    setRealValue(e);
    onChange && onChange(e, datastring);
  };
  var clearValue = function clearValue() {
    customizeOnChange(null, '');
  };
  return /*#__PURE__*/React.createElement("span", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement(DatePicker, _extends({
    ref: ref,
    value: realValue,
    onChange: customizeOnChange,
    disabled: disabled,
    allowClear: !disabled && !!allowClear,
    superNextIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "unfold"
    }),
    superPrevIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "stow"
    }),
    prevIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "leftArrow"
    }),
    nextIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "rightArrow"
    }),
    suffixIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "calendar",
      color: NORMAL_ICON_COLOR
    }),
    popupClassName: "".concat(prefixCls, "-popupClassName")
  }, restProps)), !!allowClear && !disabled && !!realValue && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-clear-icon"),
    onClick: clearValue
  }, clearIconHandle(allowClear)));
});
AntdDatePicker.MonthPicker = DatePicker.MonthPicker;
AntdDatePicker.QuarterPicker = DatePicker.QuarterPicker;
AntdDatePicker.RangePicker = RangePicker;
AntdDatePicker.TimePicker = DatePicker.TimePicker;
AntdDatePicker.WeekPicker = DatePicker.WeekPicker;
AntdDatePicker.YearPicker = DatePicker.YearPicker;
export default AntdDatePicker;