import React from 'react';
import { DatePicker } from 'antd';
import RangePicker from './RangePicker';
import type { DatePickerProps as AntdDatePickerProps } from 'antd';
import type { RangePickerProps as AntdRangePickerProps } from 'antd/es/date-picker';
import { Moment } from 'moment';
export type { TextAreaRef } from 'antd/lib/input/TextArea';
export type { MonthPickerProps, WeekPickerProps } from 'antd/es/date-picker';
export interface DatePickerProps extends Omit<AntdDatePickerProps, 'allowClear' | 'value' | 'defaultValue'> {
    allowClear?: boolean | {
        clearIcon: React.ReactNode;
    };
    value?: Moment | undefined | string | Date;
    defaultValue?: Moment | undefined | string | Date;
}
export interface RangePickerProps extends Omit<AntdRangePickerProps, 'allowClear'> {
    allowClear?: boolean | {
        clearIcon: React.ReactNode;
    };
}
export interface CompoundedComponent extends React.ForwardRefExoticComponent<DatePickerProps & React.RefAttributes<any>> {
    MonthPicker: typeof DatePicker.MonthPicker;
    QuarterPicker: typeof DatePicker.QuarterPicker;
    RangePicker: typeof RangePicker;
    TimePicker: typeof DatePicker.TimePicker;
    WeekPicker: typeof DatePicker.WeekPicker;
    YearPicker: typeof DatePicker.YearPicker;
}
