function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["titleName", "onFinish", "loading", "children", "onClose", "onOkText", "onCancelText", "className", "placement", "style"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
import { Drawer, Spin, Typography } from 'antd';
import Button from "../Button";
import Icon from "../Icon";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-drawer");
var Text = Typography.Text;

// 二次封装Drawer组件
var AntdDrawer = function AntdDrawer(_ref) {
  var titleName = _ref.titleName,
    onFinish = _ref.onFinish,
    loading = _ref.loading,
    children = _ref.children,
    onClose = _ref.onClose,
    _ref$onOkText = _ref.onOkText,
    onOkText = _ref$onOkText === void 0 ? '保存' : _ref$onOkText,
    _ref$onCancelText = _ref.onCancelText,
    onCancelText = _ref$onCancelText === void 0 ? '取消' : _ref$onCancelText,
    className = _ref.className,
    placement = _ref.placement,
    style = _ref.style,
    restProps = _objectWithoutProperties(_ref, _excluded);
  var DrawerTitle = function DrawerTitle() {
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(prefixCls, "-title")
    }, /*#__PURE__*/React.createElement(Text, {
      className: "".concat(prefixCls, "-title-name"),
      ellipsis: {
        tooltip: {
          title: titleName,
          placement: 'bottom'
        }
      }
    }, titleName), /*#__PURE__*/React.createElement("span", {
      onClick: onClose
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "close",
      style: {
        fontSize: 16
      }
    })));
  };
  var DrawerFooter = function DrawerFooter() {
    return /*#__PURE__*/React.createElement(Spin, {
      spinning: !!loading,
      wrapperClassName: "".concat(prefixCls, "-footer"),
      indicator: /*#__PURE__*/React.createElement(React.Fragment, null)
    }, /*#__PURE__*/React.createElement(Button, {
      onClick: onClose
    }, onCancelText), /*#__PURE__*/React.createElement(Button, {
      type: "primary",
      className: "".concat(prefixCls, "-save-btn"),
      onMouseDown: onFinish
    }, onOkText));
  };
  return /*#__PURE__*/React.createElement(Drawer, _extends({
    className: classnames(_defineProperty({}, "".concat(prefixCls), placement === 'right'), className),
    title: /*#__PURE__*/React.createElement(DrawerTitle, null),
    onClose: onClose,
    footer: /*#__PURE__*/React.createElement(DrawerFooter, null),
    closeIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "close",
      style: {
        fontSize: 16
      }
    }),
    placement: placement,
    width: 348
  }, restProps), /*#__PURE__*/React.createElement(Spin, {
    spinning: !!loading
  }, children));
};
AntdDrawer.defaultProps = {
  placement: 'right'
};
export default AntdDrawer;