function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["children", "formtype", "className"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { createContext, forwardRef } from 'react';
import { Form } from 'antd';
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-form");
export var FormContext = /*#__PURE__*/createContext({});

// 二次封装Form表单组件，统一修改样式，增加其查看/编辑态切换功能。
var AntdForm = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var children = _ref.children,
    _ref$formtype = _ref.formtype,
    formtype = _ref$formtype === void 0 ? 'normal' : _ref$formtype,
    className = _ref.className,
    restProps = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(Form, _extends({
    ref: ref,
    className: classnames(className, "".concat(prefixCls, "-normal"), _defineProperty({}, "".concat(prefixCls, "-broswer"), formtype === "broswer"))
  }, restProps), /*#__PURE__*/React.createElement(FormContext.Provider, {
    value: {
      formtype: formtype
    }
  }, children));
});
AntdForm.useForm = Form.useForm;
AntdForm.useFormInstance = Form.useFormInstance;
AntdForm.List = Form.List;
AntdForm.ErrorList = Form.ErrorList;
AntdForm.Provider = Form.Provider;
AntdForm.useWatch = Form.useWatch;
AntdForm.Item = Form.Item;
AntdForm.FormContext = FormContext;
export default AntdForm;