import React from 'react';
import { Form } from 'antd';
import type { FormProps as AntdFormProps } from 'antd';
export type { FormInstance, FormItemProps, FormListFieldData, FormListOperation, Rule as FormRule, } from 'antd/lib/form';
export interface FormProps extends AntdFormProps {
    formtype?: 'broswer' | 'normal';
}
export interface CompoundedComponent extends React.ForwardRefExoticComponent<FormProps> {
    useForm: typeof Form.useForm;
    useFormInstance: typeof Form.useFormInstance;
    useWatch: typeof Form.useWatch;
    Item: typeof Form.Item;
    List: typeof Form.List;
    ErrorList: typeof Form.ErrorList;
    Provider: typeof Form.Provider;
    formtype?: 'broswer' | 'normal';
    FormContext: React.Context<{
        formtype?: 'broswer' | 'normal';
    }>;
    children?: React.ReactNode;
}
