import React from 'react';
export interface IconProps {
    /** 设置图标的样式名 */
    className?: string;
    /** 直接设置icon的color */
    color?: string;
    /** 点击事件 */
    onClick?: (e: React.MouseEvent<HTMLSpanElement, MouseEvent>) => void;
    /** 图标旋转角度（IE9 无效） */
    rotate?: number;
    /** 设置图标的样式，例如 fontSize 和 color */
    style?: React.CSSProperties;
    /** 直接设置icon的font-size */
    size?: number;
    /** 是否有旋转动画 */
    spin?: boolean;
    /** icon名 */
    type: string;
    /** cursor: inherit */
    cursorInherit?: boolean;
}
