var _excluded = ["allowClear", "disabled", "onChange", "value", "defaultValue", "style"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { Input } from 'antd';
import { PREFIX_CLS } from "../constants/dictionary";
import { clearIconHandle } from "./Input";
import useMergedState from 'rc-util/lib/hooks/useMergedState';
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-input");
var TextArea = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _ref$allowClear = _ref.allowClear,
    allowClear = _ref$allowClear === void 0 ? true : _ref$allowClear,
    disabled = _ref.disabled,
    onChange = _ref.onChange,
    value = _ref.value,
    defaultValue = _ref.defaultValue,
    style = _ref.style,
    restProps = _objectWithoutProperties(_ref, _excluded);
  var _useMergedState = useMergedState(defaultValue, {
      value: value
    }),
    _useMergedState2 = _slicedToArray(_useMergedState, 2),
    val = _useMergedState2[0],
    setVal = _useMergedState2[1];
  var handleChange = function handleChange(e) {
    setVal(e.target.value);
    onChange && onChange(e);
  };
  var handleClear = function handleClear() {
    handleChange({
      target: {
        value: ''
      }
    });
  };
  return /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-textarea"),
    style: {
      width: style === null || style === void 0 ? void 0 : style.width
    }
  }, /*#__PURE__*/React.createElement(Input.TextArea, _extends({
    disabled: disabled,
    onChange: handleChange,
    value: val,
    ref: ref,
    style: style
  }, restProps, {
    allowClear: false
  })), !!allowClear && !disabled && !!val && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-textarea-clear-icon"),
    onClick: handleClear
  }, clearIconHandle(allowClear)));
});
export default TextArea;