/// <reference types="react" />
import Search from './Search';
import TextArea from './TextArea';
import FillSearch from './FillSearch';
import { Input } from 'antd';
import EnterSearch from './EnterSearch';
import type { TextAreaProps as AntdTextAreaProps } from 'antd/lib/input';
import type { InputRef, InputProps } from 'antd';
export type { InputRef, InputProps } from 'antd';
export type { TextAreaRef } from 'antd/lib/input/TextArea';
export interface TextAreaProps extends Omit<AntdTextAreaProps, 'allowClear'> {
    allowClear?: boolean | {
        clearIcon: React.ReactNode;
    };
}
export type { SearchProps } from 'antd/lib/input';
export interface CompoundedComponent extends React.ForwardRefExoticComponent<InputProps & React.RefAttributes<InputRef>> {
    Group: typeof Input.Group;
    Search: typeof Search;
    TextArea: typeof TextArea;
    FillSearch: typeof FillSearch;
    Password: typeof Input.Password;
    EnterSearch: typeof EnterSearch;
}
