function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React from 'react';
import Icon from "../Icon";
import Typography from "../Typography";
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
var prefixCls = "".concat(PREFIX_CLS, "-pageTitle");
import "./style/index.less";
var LongText = Typography.LongText;
var Title = function Title(_ref) {
  var text = _ref.text,
    icon = _ref.icon,
    _onClick = _ref.onClick,
    disabled = _ref.disabled,
    titleLength = _ref.titleLength;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames("".concat(prefixCls, "-title"), _defineProperty({}, "".concat(prefixCls, "-title-disabled"), disabled))
  }, icon && /*#__PURE__*/React.createElement("span", {
    onClick: function onClick() {
      if (disabled) return;
      if (_onClick) {
        _onClick();
        return;
      }
      history.back();
    }
  }, icon), /*#__PURE__*/React.createElement("span", null, typeof text === 'string' ? /*#__PURE__*/React.createElement(LongText, {
    text: text,
    length: titleLength,
    tooltip: text
  }) : text));
};
Title.defaultProps = {
  icon: /*#__PURE__*/React.createElement(Icon, {
    type: "guidanceArrowLeft",
    size: 22
  })
};
var PageTitle = function PageTitle(_ref2) {
  var icon = _ref2.icon,
    title = _ref2.title,
    _ref2$titleLength = _ref2.titleLength,
    titleLength = _ref2$titleLength === void 0 ? 10 : _ref2$titleLength,
    style = _ref2.style,
    action = _ref2.action,
    onClick = _ref2.onClick,
    bordered = _ref2.bordered,
    borderedBottom = _ref2.borderedBottom,
    disabled = _ref2.disabled,
    className = _ref2.className,
    centerNode = _ref2.centerNode;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(prefixCls, _defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-bordered"), bordered), "".concat(prefixCls, "-borderedBottom"), borderedBottom), "".concat(prefixCls, "-disabled"), disabled))
  }, /*#__PURE__*/React.createElement("div", {
    style: style,
    className: classnames("".concat(prefixCls, "-container"), className)
  }, /*#__PURE__*/React.createElement(Title, {
    text: title,
    icon: icon,
    onClick: onClick,
    disabled: disabled,
    titleLength: titleLength
  }), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-centerNode")
  }, centerNode), /*#__PURE__*/React.createElement("div", null, action)));
};
PageTitle.defaultProps = {
  bordered: false,
  disabled: false,
  titleLength: 10
};
export default PageTitle;