var _excluded = ["children", "onDropdownVisibleChange", "mode", "disabled", "className", "popupClassName", "needActive", "onChange", "loading", "open", "size", "maxTagTextLength", "iconType", "iconStyle", "iconClassName"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState, useEffect, forwardRef } from 'react';
import { Select } from 'antd';
import Typography from "../Typography";
import { LoadingOutlined } from '@ant-design/icons';
import classnames from 'classnames';
import Icon from "../Icon";
import Tag from "../Tag";
import { PREFIX_CLS, normal_text_color, disabled_text_color } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-select");
var LongText = Typography.LongText;
var HEIGHT = {
  large: 30,
  middle: 24,
  small: 18
};

// 二次封装Select组件，实现下拉显示时右侧箭头图标翻转，统一Tag标签样式
var AntdSelect = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var children = _ref.children,
    onDropdownVisibleChange = _ref.onDropdownVisibleChange,
    mode = _ref.mode,
    disabled = _ref.disabled,
    className = _ref.className,
    popupClassName = _ref.popupClassName,
    needActive = _ref.needActive,
    realChange = _ref.onChange,
    loading = _ref.loading,
    open = _ref.open,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 'middle' : _ref$size,
    maxTagTextLength = _ref.maxTagTextLength,
    _ref$iconType = _ref.iconType,
    iconType = _ref$iconType === void 0 ? 'downArrow' : _ref$iconType,
    iconStyle = _ref.iconStyle,
    iconClassName = _ref.iconClassName,
    restProps = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isActive = _useState2[0],
    setIsActive = _useState2[1];

  /**
   * 如果从外面传入了open，那么通过这个open来判断箭头的翻转。
   * 为什么这么做？
   * 因为在使用dropdownRender自定义下拉项的时候，需要手动设置open来控制下拉框的显示，
   * 但是在这么做之后不会触发onDropdownVisibleChange，因此无法将箭头翻转，所以需要在这里监听一下是否有从外部传入的open。
   * */
  useEffect(function () {
    if (open === undefined) return;
    needActive && setIsActive(open);
  }, [open]);
  var onChange = function onChange(e, options) {
    realChange && realChange(e, options);
  };
  var onPreventMouseDown = function onPreventMouseDown(event) {
    event.preventDefault();
    event.stopPropagation();
  };
  var _onClick = function onClick(visiable) {
    // 这里加个判断，open是否从外部传入，如果是从外部传入的，那么走useEffect中的逻辑就行
    onDropdownVisibleChange && onDropdownVisibleChange(visiable);
    if (open !== undefined) {
      return needActive && setIsActive(open);
    }
    setIsActive(visiable);
  };
  return /*#__PURE__*/React.createElement(Select, _extends({
    ref: ref,
    className: classnames(prefixCls, className),
    suffixIcon: !loading ? /*#__PURE__*/React.createElement(Icon, {
      onClick: function onClick() {
        return _onClick(!isActive);
      },
      type: iconType,
      color: disabled ? disabled_text_color : normal_text_color,
      rotate: isActive && needActive && !disabled ? 180 : 0,
      style: iconStyle,
      className: iconClassName
    }) : /*#__PURE__*/React.createElement(LoadingOutlined, null),
    open: isActive,
    onChange: onChange,
    popupClassName: classnames("".concat(prefixCls, "-dropdown"), popupClassName),
    onDropdownVisibleChange: _onClick,
    mode: mode,
    disabled: disabled,
    clearIcon: /*#__PURE__*/React.createElement(Icon, {
      size: 16,
      type: "closeAreality",
      color: normal_text_color
    }),
    size: size,
    menuItemSelectedIcon: mode === 'multiple' || mode === 'tags' ? /*#__PURE__*/React.createElement(React.Fragment, null) : /*#__PURE__*/React.createElement(Icon, {
      type: "confirm"
    }),
    filterOption: function filterOption(input, option) {
      var _option$label;
      return ((_option$label = option === null || option === void 0 ? void 0 : option.label) !== null && _option$label !== void 0 ? _option$label : '').toLowerCase().includes(input.toLowerCase());
    },
    tagRender: function tagRender(item) {
      var onClose = item.onClose;
      var label = typeof item.label === 'string' ? /*#__PURE__*/React.createElement(LongText, {
        text: item.label,
        length: maxTagTextLength
      }) : item.label;
      return /*#__PURE__*/React.createElement(Tag, {
        className: "".concat(prefixCls, "-tag"),
        type: disabled ? 'disabled' : 'selected',
        height: HEIGHT[size],
        closable: !disabled,
        onClick: function onClick() {
          return needActive && setIsActive(!isActive);
        },
        onMouseDown: onPreventMouseDown,
        onClose: onClose
      }, label);
    }
  }, restProps), children);
});
AntdSelect.Option = Select.Option;
AntdSelect.OptGroup = Select.OptGroup;
AntdSelect.defaultProps = {
  showSearch: true,
  needActive: true,
  allowClear: true,
  maxTagTextLength: 4
};
export default AntdSelect;