function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["options", "value", "defaultValue", "onChange", "onFocus", "onSearch", "disabled", "onClear", "showSelectAll", "notFoundContent", "displayType", "maxTagTextLength", "popupClassName", "maxTagCount", "labelRender", "fixedSizeListProps", "onDropdownVisibleChange", "orginConfig", "optionsOrgin"],
  _excluded2 = ["optionsDataHandle", "onSuccess"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState, useMemo, useEffect, useRef, forwardRef } from 'react';
import { Checkbox, Empty, Tooltip, Popover, Spin } from 'antd';
import { useInfiniteScroll, useRequest } from 'ahooks';
import { FixedSizeList } from 'react-window';
import Tag from "../Tag";
import Select from "../Select";
import Typography from "../Typography";
import { PREFIX_CLS } from "../constants/dictionary";
import classNames from 'classnames';
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-selectCheckbox");
var CheckboxGroup = Checkbox.Group;
var LongText = Typography.LongText,
  TextOverFlow = Typography.TextOverFlow;
var LoadingSpin = function LoadingSpin() {
  return /*#__PURE__*/React.createElement("div", {
    style: {
      textAlign: 'center',
      padding: 10
    }
  }, /*#__PURE__*/React.createElement(Spin, {
    size: "small"
  }));
};

// 下拉多选样式封装，主要是因为其样式改动过大，因此重新封装了一个
var SelectCheckbox = /*#__PURE__*/forwardRef(function (props, ref) {
  var OPTIONS_ORIGIN = function OPTIONS_ORIGIN() {
    return Promise.resolve();
  };
  var _props$options = props.options,
    realOptions = _props$options === void 0 ? [] : _props$options,
    realValue = props.value,
    realDefaultValue = props.defaultValue,
    realChange = props.onChange,
    onFocus = props.onFocus,
    onSearch = props.onSearch,
    disabled = props.disabled,
    onClear = props.onClear,
    showSelectAll = props.showSelectAll,
    notFoundContent = props.notFoundContent,
    displayType = props.displayType,
    _props$maxTagTextLeng = props.maxTagTextLength,
    maxTagTextLength = _props$maxTagTextLeng === void 0 ? 4 : _props$maxTagTextLeng,
    popupClassName = props.popupClassName,
    _props$maxTagCount = props.maxTagCount,
    maxTagCount = _props$maxTagCount === void 0 ? 50 : _props$maxTagCount,
    labelRender = props.labelRender,
    fixedSizeListProps = props.fixedSizeListProps,
    onDropdownVisibleChange = props.onDropdownVisibleChange,
    orginConfig = props.orginConfig,
    optionsOrgin = props.optionsOrgin,
    restProps = _objectWithoutProperties(props, _excluded);
  var _ref = orginConfig || {},
    optionsDataHandle = _ref.optionsDataHandle,
    _onSuccess = _ref.onSuccess,
    restOriginConfig = _objectWithoutProperties(_ref, _excluded2);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    open = _useState2[0],
    setOpen = _useState2[1];
  var _useState3 = useState(),
    _useState4 = _slicedToArray(_useState3, 2),
    dataOptions = _useState4[0],
    setDataOptions = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    searchVal = _useState6[0],
    setSearchVal = _useState6[1];
  var _useState7 = useState(new Map([])),
    _useState8 = _slicedToArray(_useState7, 1),
    initOptionsMap = _useState8[0];
  var _useState9 = useState([]),
    _useState10 = _slicedToArray(_useState9, 2),
    value = _useState10[0],
    setValue = _useState10[1];
  var _useState11 = useState(false),
    _useState12 = _slicedToArray(_useState11, 2),
    popverOpen = _useState12[0],
    setPopverOpen = _useState12[1];
  var lastChecked = useRef(false);
  var popverRef = useRef(null);
  var _useRequest = useRequest(optionsOrgin || OPTIONS_ORIGIN, _objectSpread({
      manual: true,
      onSuccess: function onSuccess(res, params) {
        _onSuccess && _onSuccess(res, params);
        setDataOptions(optionsDataHandle ? optionsDataHandle(res) : res);
      }
    }, restOriginConfig)),
    run = _useRequest.run,
    loading = _useRequest.loading;
  useEffect(function () {
    setValue(initValue());
  }, [realValue, realDefaultValue]);
  var options = useMemo(function () {
    return dataOptions || realOptions || [];
  }, [realOptions, dataOptions]);
  var _useMemo = useMemo(function () {
      return {
        indeterminate: !!value.length && value.length < options.length,
        checked: value.length >= options.length
      };
    }, [value, options]),
    indeterminate = _useMemo.indeterminate,
    checked = _useMemo.checked;
  var getLoadMoreList = function getLoadMoreList(nextId, limit) {
    var start = 0;
    if (nextId) {
      start = slicedArray.findIndex(function (i) {
        return i.value === nextId;
      });
    }
    var end = start + limit;
    var list = slicedArray.slice(start, end);
    var nId = slicedArray.length >= end ? slicedArray[end].value : undefined;
    return new Promise(function (resolve) {
      resolve({
        list: list,
        nextId: nId
      });
    });
  };

  // 初始值value
  var initValue = function initValue() {
    if (!realValue && !realDefaultValue) return [];
    var temp = realValue || realDefaultValue;
    var _value = Array.isArray(temp) ? temp : [temp];
    var values = _value === null || _value === void 0 ? void 0 : _value.map(function (item) {
      var isObject = item instanceof Object;
      var label = isObject ? item === null || item === void 0 ? void 0 : item.label : item;
      var value = isObject ? item === null || item === void 0 ? void 0 : item.value : item;
      // 这里初始化的时候保留第一次传入的值，防止不在下拉选项中的值传进来出现展示问题
      initOptionsMap.set(value, label);
      return value;
    });
    return values;
  };

  // checkoutBox展示的数据
  var _useMemo2 = useMemo(function () {
      var normalOptions = [];
      var checkedDisabledOptions = [];
      var disabledOptionValue = [];
      var filterOption = options === null || options === void 0 ? void 0 : options.filter(function (i) {
        var label = i.label,
          disabled = i.disabled,
          tmp = i.value;
        if (!disabled || value.includes(tmp)) {
          normalOptions.push(tmp);
        }
        if (value.includes(tmp) && disabled) {
          checkedDisabledOptions.push(tmp);
        }
        if (disabled) {
          disabledOptionValue.push(tmp);
        }
        return label.includes(searchVal);
      });
      return {
        filterOption: filterOption,
        normalOptions: normalOptions,
        checkedDisabledOptions: checkedDisabledOptions,
        disabledOptionValue: disabledOptionValue
      };
    }, [searchVal, options, value]),
    filterOption = _useMemo2.filterOption,
    normalOptions = _useMemo2.normalOptions,
    checkedDisabledOptions = _useMemo2.checkedDisabledOptions,
    disabledOptionValue = _useMemo2.disabledOptionValue;

  //  option全部数据，map结构
  var optionsMap = useMemo(function () {
    var data = new Map();
    options.map(function (_ref2) {
      var label = _ref2.label,
        value = _ref2.value;
      return data.set(value, label);
    });
    return data;
  }, [options]);
  var onMergeChange = function onMergeChange(value) {
    realChange && realChange(value.map(function (item) {
      return {
        label: optionsMap.get(item) || initOptionsMap.get(item),
        value: item
      };
    }), options);
    setValue(value);
  };
  var onCheckboxChange = function onCheckboxChange(e) {
    var list;
    if (Array.isArray(e)) {
      list = e;
    } else {
      var _e$target = e.target,
        targetValue = _e$target.value,
        _checked = _e$target.checked;
      list = _checked ? value.concat([targetValue]) : deleteOne(targetValue);
    }
    onMergeChange(list);
    setSearchVal('');
  };
  var onCheckAllChange = function onCheckAllChange(e) {
    var checked = e.target.checked;
    var newOptions = [];
    if (checked && !lastChecked.current) {
      newOptions = normalOptions;
      lastChecked.current = true;
    } else {
      newOptions = checkedDisabledOptions;
      lastChecked.current = false;
    }
    // 设置value值
    onMergeChange(newOptions);
  };

  // 删除已选中的一项
  var deleteOne = function deleteOne(val) {
    var index = value.indexOf(val);
    var copyCheckList = _toConsumableArray(value);
    copyCheckList.splice(index, 1);
    return copyCheckList;
  };

  // 点击标签关闭按钮时触发
  var tagClose = function tagClose(value) {
    onCheckboxChange(deleteOne(value));
  };
  var RowItem = function RowItem(_ref3) {
    var index = _ref3.index,
      style = _ref3.style;
    var _filterOption$index = filterOption[index],
      label = _filterOption$index.label,
      value = _filterOption$index.value,
      disabled = _filterOption$index.disabled;
    return /*#__PURE__*/React.createElement(Checkbox, {
      key: value,
      value: value,
      style: _objectSpread(_objectSpread({}, style), {}, {
        width: 'calc(100% - 16px)'
      }),
      className: "".concat(prefixCls, "-item-checkbox"),
      onChange: onCheckboxChange,
      disabled: disabled
    }, labelRender ? labelRender(filterOption[index]) : /*#__PURE__*/React.createElement(TextOverFlow, null, label || '-'));
  };
  var getDropdownRender = function getDropdownRender() {
    var showAll = showSelectAll && !!options.length;
    var realNotFoundContent = loading ? /*#__PURE__*/React.createElement(LoadingSpin, null) : notFoundContent;
    var length = filterOption === null || filterOption === void 0 ? void 0 : filterOption.length;
    var height = length > 7 ? 250 : length * ((fixedSizeListProps === null || fixedSizeListProps === void 0 ? void 0 : fixedSizeListProps.itemSize) || 33);
    return /*#__PURE__*/React.createElement(React.Fragment, null, showAll && /*#__PURE__*/React.createElement(Checkbox, {
      className: "".concat(prefixCls, "-dropdown-header"),
      indeterminate: indeterminate,
      onChange: onCheckAllChange,
      checked: checked
    }, "\u5168\u9009"), /*#__PURE__*/React.createElement("div", null, !filterOption || !length ? realNotFoundContent : /*#__PURE__*/React.createElement(CheckboxGroup, {
      className: "".concat(prefixCls, "-dropdown-option"),
      value: value
    }, /*#__PURE__*/React.createElement(FixedSizeList, _extends({
      height: height,
      itemSize: 32,
      itemCount: length
    }, fixedSizeListProps), RowItem))));
  };

  // 这里将在options中的默认值和不在options中的默认值合并在一起，并过滤只有一个value值的数据（只有一个value，并且这个value在options中不存在）
  var _useMemo3 = useMemo(function () {
      var data = realValue || [];
      var optionsMapTemp = new Map(optionsMap);
      data.forEach(function (item) {
        if (typeof item !== 'string' && item !== null && item !== void 0 && item.value) {
          optionsMapTemp.set(item === null || item === void 0 ? void 0 : item.value, item === null || item === void 0 ? void 0 : item.label);
        }
      });
      var mergeData = value.map(function (value) {
        return {
          label: optionsMapTemp.get(value),
          value: value
        };
      }).filter(function (_ref4) {
        var label = _ref4.label;
        return label !== undefined;
      });
      var slicedArray = [];
      if (maxTagCount && maxTagCount !== 'responsive') {
        slicedArray = mergeData.slice(maxTagCount, mergeData === null || mergeData === void 0 ? void 0 : mergeData.length);
      }
      return {
        mergeData: mergeData,
        slicedArray: slicedArray
      };
    }, [realValue, optionsMap, value]),
    mergeData = _useMemo3.mergeData,
    slicedArray = _useMemo3.slicedArray;
  var _useInfiniteScroll = useInfiniteScroll(function (d) {
      return getLoadMoreList(d === null || d === void 0 ? void 0 : d.nextId, 41);
    }, {
      target: popverRef,
      isNoMore: function isNoMore(d) {
        return (d === null || d === void 0 ? void 0 : d.nextId) === undefined;
      },
      reloadDeps: [popverOpen]
    }),
    popoverData = _useInfiniteScroll.data;
  var onPreventMouseDown = function onPreventMouseDown(e) {
    e.preventDefault();
    e.stopPropagation();
  };
  var tagProps = {
    className: "".concat(prefixCls, "-dropdown-tag"),
    height: 24,
    onMouseDown: onPreventMouseDown,
    onClick: function onClick(e) {
      onPreventMouseDown(e);
      setOpen(!open);
    }
  };
  var getContentRender = function getContentRender() {
    var _popoverData$list;
    return /*#__PURE__*/React.createElement("div", {
      ref: popverRef,
      style: {
        maxHeight: 130,
        overflow: 'auto'
      }
    }, popoverData === null || popoverData === void 0 || (_popoverData$list = popoverData.list) === null || _popoverData$list === void 0 ? void 0 : _popoverData$list.map(function (_ref5) {
      var label = _ref5.label,
        value = _ref5.value;
      var tagDisabled = disabledOptionValue.includes(value);
      var tooltip = (label === null || label === void 0 ? void 0 : label.length) < maxTagTextLength || disabled ? undefined : label;
      return /*#__PURE__*/React.createElement(Tooltip, {
        key: value,
        title: tooltip
      }, /*#__PURE__*/React.createElement(Tag, _extends({
        type: tagDisabled ? 'disabled' : 'selected'
      }, tagProps, {
        disabled: tagDisabled,
        closable: !tagDisabled && !disabled,
        onClose: function onClose() {
          return tagClose(value);
        }
      }), /*#__PURE__*/React.createElement(LongText, {
        text: label,
        length: maxTagTextLength
      })));
    }));
  };
  var getMoreTag = function getMoreTag() {
    if (maxTagCount === 'responsive') return;
    var length = slicedArray === null || slicedArray === void 0 ? void 0 : slicedArray.length;
    return /*#__PURE__*/React.createElement(Popover, {
      content: getContentRender(),
      onOpenChange: setPopverOpen,
      overlayClassName: "".concat(prefixCls, "-popover-class")
    }, /*#__PURE__*/React.createElement("span", null, "+", length, "..."));
  };
  var getTag = function getTag(tagValue, label, tagDisabled) {
    var tooltip = (label === null || label === void 0 ? void 0 : label.length) < maxTagTextLength || disabled ? undefined : label;
    return /*#__PURE__*/React.createElement(Tooltip, {
      title: tooltip
    }, /*#__PURE__*/React.createElement(Tag, _extends({
      key: tagValue,
      type: disabled ? 'disabled' : 'selected'
    }, tagProps, {
      disabled: tagDisabled,
      closable: !tagDisabled && !disabled,
      onClose: function onClose() {
        return tagClose(tagValue);
      }
    }), /*#__PURE__*/React.createElement(LongText, {
      text: label,
      length: maxTagTextLength
    })));
  };
  var getTagRender = function getTagRender(_ref6) {
    var _mergeData$find;
    var tagValue = _ref6.value;
    var tagDisabled = disabledOptionValue.includes(tagValue);
    var label = (mergeData === null || mergeData === void 0 || (_mergeData$find = mergeData.find(function (item) {
      return (item === null || item === void 0 ? void 0 : item.value) === tagValue;
    })) === null || _mergeData$find === void 0 ? void 0 : _mergeData$find.label) || '';
    // 是否是最后一条标签，如果是最后一项，那么不加分隔符
    var isLastLabel = value[value.length - 1] === tagValue;
    // displayType是否为字符串，如果为对象那么取对象里面的分隔符
    var isString = typeof displayType === 'string';
    // 是否不是标签模式
    var isNotTag = displayType !== 'tag';
    // 当前分隔符
    var separated = !isLastLabel ? isString ? '、' : displayType === null || displayType === void 0 ? void 0 : displayType.separated : '';
    // 当前展示的标签
    var tag = getTag(tagValue, label, tagDisabled);
    return /*#__PURE__*/React.createElement(React.Fragment, null, label && (isNotTag ? "".concat(label).concat(separated) : tag));
  };
  var onMergeDropdownVisibleChange = function onMergeDropdownVisibleChange(open) {
    setOpen(open);
    onDropdownVisibleChange && onDropdownVisibleChange(open);
    open && optionsOrgin && run();
  };
  var onMergeClear = function onMergeClear() {
    // 这里加个setTimeout，因为不加的话Select组件本身的清除事件就会把数据清除
    setTimeout(function () {
      onCheckboxChange(checkedDisabledOptions);
    });
    onClear && onClear();
  };
  var onMergeFocus = function onMergeFocus(e) {
    onFocus && onFocus(e);
    setSearchVal('');
  };
  var onMergeSearch = function onMergeSearch(e) {
    onSearch && onSearch(e);
    setSearchVal(e);
  };
  return /*#__PURE__*/React.createElement(Select, _extends({
    ref: ref,
    open: open,
    options: options,
    showArrow: true,
    value: value,
    showSearch: true,
    onFocus: onMergeFocus,
    onSearch: onMergeSearch,
    onChange: onMergeChange,
    onClear: onMergeClear,
    onDropdownVisibleChange: onMergeDropdownVisibleChange,
    disabled: disabled,
    popupClassName: classNames("".concat(prefixCls, "-dropdown"), popupClassName),
    maxTagCount: maxTagCount,
    maxTagPlaceholder: getMoreTag(),
    tagRender: getTagRender,
    dropdownRender: getDropdownRender
  }, restProps, {
    mode: "multiple"
  }));
});
SelectCheckbox.defaultProps = {
  showSelectAll: true,
  maxTagTextLength: 4,
  displayType: 'tag',
  maxTagCount: 50,
  notFoundContent: /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE,
    description: "\u6682\u65E0\u6570\u636E"
  })
};
export default SelectCheckbox;