import React from 'react';
import type { SelectProps } from '../Select';
import type { RefSelectProps } from 'antd';
import type { Service, Options } from 'ahooks/lib/useRequest/src/types.d';
export interface SelectionItemType {
    label: string;
    value: React.Key;
    key?: React.Key;
    disabled?: boolean;
}
export interface SelectCheckboxProps extends SelectProps {
    /** 选项值 */
    options: SelectionItemType[];
    /** 是否展示全选 */
    showSelectAll?: boolean;
    /** 数据展示形式，标签展示或文字展示，为对象时设置separated为text的分隔符 */
    displayType?: 'tag' | 'text' | {
        separated: string;
    };
    /** 自定义选项label展示 */
    labelRender?: (option: SelectionItemType) => React.ReactNode;
    optionsOrgin?: Service<any, [data: object]>;
    orginConfig?: Options<any, any> & {
        optionsDataHandle?: (data: any) => SelectProps['options'];
    };
    fixedSizeListProps?: {
        height?: number;
        itemSize?: number;
        itemCoun?: number;
    };
}
export interface CompoundedComponent extends React.ForwardRefExoticComponent<SelectCheckboxProps & React.RefAttributes<RefSelectProps>> {
}
export interface Result {
    list: any[];
    nextId?: React.Key;
}
