function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/**
 * title: 按钮/头像/输入框/图像/自定义节点
 * desc: 骨架按钮、头像、输入框、图像和自定义节点。
 * slug: true
 */

import { Divider, Form, Radio, Skeleton, Space, Switch } from 'antd';
import { DotChartOutlined } from '@ant-design/icons';
import React, { useState } from 'react';
var App = function App() {
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    active = _useState2[0],
    setActive = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    block = _useState4[0],
    setBlock = _useState4[1];
  var _useState5 = useState('default'),
    _useState6 = _slicedToArray(_useState5, 2),
    size = _useState6[0],
    setSize = _useState6[1];
  var _useState7 = useState('default'),
    _useState8 = _slicedToArray(_useState7, 2),
    buttonShape = _useState8[0],
    setButtonShape = _useState8[1];
  var _useState9 = useState('circle'),
    _useState10 = _slicedToArray(_useState9, 2),
    avatarShape = _useState10[0],
    setAvatarShape = _useState10[1];
  var handleActiveChange = function handleActiveChange(checked) {
    setActive(checked);
  };
  var handleBlockChange = function handleBlockChange(checked) {
    setBlock(checked);
  };
  var handleSizeChange = function handleSizeChange(e) {
    setSize(e.target.value);
  };
  var handleShapeButton = function handleShapeButton(e) {
    setButtonShape(e.target.value);
  };
  var handleAvatarShape = function handleAvatarShape(e) {
    setAvatarShape(e.target.value);
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Space, null, /*#__PURE__*/React.createElement(Skeleton.Button, {
    active: active,
    size: size,
    shape: buttonShape,
    block: block
  }), /*#__PURE__*/React.createElement(Skeleton.Avatar, {
    active: active,
    size: size,
    shape: avatarShape
  }), /*#__PURE__*/React.createElement(Skeleton.Input, {
    active: active,
    size: size
  })), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Skeleton.Button, {
    active: active,
    size: size,
    shape: buttonShape,
    block: block
  }), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Skeleton.Input, {
    active: active,
    size: size,
    block: block
  }), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Space, null, /*#__PURE__*/React.createElement(Skeleton.Image, {
    active: active
  }), /*#__PURE__*/React.createElement(Skeleton.Node, {
    active: active
  }, /*#__PURE__*/React.createElement(DotChartOutlined, {
    style: {
      fontSize: 40,
      color: '#bfbfbf'
    }
  }))), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement(Form, {
    layout: "inline",
    style: {
      margin: '16px 0'
    }
  }, /*#__PURE__*/React.createElement(Form.Item, {
    label: "Active"
  }, /*#__PURE__*/React.createElement(Switch, {
    checked: active,
    onChange: handleActiveChange
  })), /*#__PURE__*/React.createElement(Form.Item, {
    label: "Button and Input Block"
  }, /*#__PURE__*/React.createElement(Switch, {
    checked: block,
    onChange: handleBlockChange
  })), /*#__PURE__*/React.createElement(Form.Item, {
    label: "Size"
  }, /*#__PURE__*/React.createElement(Radio.Group, {
    value: size,
    onChange: handleSizeChange
  }, /*#__PURE__*/React.createElement(Radio.Button, {
    value: "default"
  }, "Default"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "large"
  }, "Large"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "small"
  }, "Small"))), /*#__PURE__*/React.createElement(Form.Item, {
    label: "Button Shape"
  }, /*#__PURE__*/React.createElement(Radio.Group, {
    value: buttonShape,
    onChange: handleShapeButton
  }, /*#__PURE__*/React.createElement(Radio.Button, {
    value: "default"
  }, "Default"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "square"
  }, "Square"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "round"
  }, "Round"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "circle"
  }, "Circle"))), /*#__PURE__*/React.createElement(Form.Item, {
    label: "Avatar Shape"
  }, /*#__PURE__*/React.createElement(Radio.Group, {
    value: avatarShape,
    onChange: handleAvatarShape
  }, /*#__PURE__*/React.createElement(Radio.Button, {
    value: "square"
  }, "Square"), /*#__PURE__*/React.createElement(Radio.Button, {
    value: "circle"
  }, "Circle")))));
};
export default App;