function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/**
 * title: 列表
 * desc: 在列表组件中使用加载占位符。
 * slug: true
 */

import { LikeOutlined, MessageOutlined, StarOutlined } from '@ant-design/icons';
import { Avatar, List, Skeleton, Switch } from 'antd';
import React, { useState } from 'react';
var listData = Array.from({
  length: 3
}).map(function (_, i) {
  return {
    href: 'https://ant.design',
    title: "ant design part ".concat(i),
    avatar: 'https://joeschmoe.io/api/v1/random',
    description: 'Ant Design, a design language for background applications, is refined by Ant UED Team.',
    content: 'We supply a series of design principles, practical patterns and high quality design resources (Sketch and Axure), to help people create their product prototypes beautifully and efficiently.'
  };
});
var IconText = function IconText(_ref) {
  var icon = _ref.icon,
    text = _ref.text;
  return /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(icon, {
    style: {
      marginRight: 8
    }
  }), text);
};
var App = function App() {
  var _useState = useState(true),
    _useState2 = _slicedToArray(_useState, 2),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var onChange = function onChange(checked) {
    setLoading(!checked);
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Switch, {
    checked: !loading,
    onChange: onChange
  }), /*#__PURE__*/React.createElement(List, {
    itemLayout: "vertical",
    size: "large",
    dataSource: listData,
    renderItem: function renderItem(item) {
      return /*#__PURE__*/React.createElement(List.Item, {
        key: item.title,
        actions: !loading ? [/*#__PURE__*/React.createElement(IconText, {
          icon: StarOutlined,
          text: "156",
          key: "list-vertical-star-o"
        }), /*#__PURE__*/React.createElement(IconText, {
          icon: LikeOutlined,
          text: "156",
          key: "list-vertical-like-o"
        }), /*#__PURE__*/React.createElement(IconText, {
          icon: MessageOutlined,
          text: "2",
          key: "list-vertical-message"
        })] : undefined,
        extra: !loading && /*#__PURE__*/React.createElement("img", {
          width: 272,
          alt: "logo",
          src: "https://gw.alipayobjects.com/zos/rmsportal/mqaQswcyDLcXyDKnZfES.png"
        })
      }, /*#__PURE__*/React.createElement(Skeleton, {
        loading: loading,
        active: true,
        avatar: true
      }, /*#__PURE__*/React.createElement(List.Item.Meta, {
        avatar: /*#__PURE__*/React.createElement(Avatar, {
          src: item.avatar
        }),
        title: /*#__PURE__*/React.createElement("a", {
          href: item.href
        }, item.title),
        description: item.description
      }), item.content));
    }
  }));
};
export default App;
{
  /* <style>
  .skeleton-demo {
  border: 1px solid #f4f4f4;
  }
  </style> */
}