function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["children", "type", "className", "closable", "disabled", "suffix", "height", "style", "bordered"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef } from 'react';
import { Tag } from 'antd';
import classnames from 'classnames';
import Icon from "../Icon";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-tag");

// 二次封装Tag组件，增加几种自定义的标签样式，通过type来进行选择
var AntdTag = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var children = _ref.children,
    type = _ref.type,
    className = _ref.className,
    closable = _ref.closable,
    disabled = _ref.disabled,
    suffix = _ref.suffix,
    height = _ref.height,
    style = _ref.style,
    bordered = _ref.bordered,
    restProps = _objectWithoutProperties(_ref, _excluded);
  height = typeof height === 'string' ? height : height + 'px';
  return /*#__PURE__*/React.createElement(Tag, _extends({
    ref: ref,
    className: classnames(prefixCls, "".concat(prefixCls, "-").concat(disabled ? 'disabled' : type), className),
    closeIcon: /*#__PURE__*/React.createElement(Icon, {
      type: "close",
      size: 12
    }),
    closable: type !== 'disabled' && !disabled && closable,
    style: _objectSpread({
      height: height,
      lineHeight: height,
      borderWidth: bordered ? 1 : 0
    }, style)
  }, restProps), children, suffix && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-suffix-icon")
  }, suffix));
});
AntdTag.CheckableTag = Tag.CheckableTag;
AntdTag.defaultProps = {
  style: {},
  bordered: false
};
export default AntdTag;