function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["multiple", "rootClassName", "checkStrictly", "defaultCheckedKeys", "onCheck"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState, useMemo, forwardRef } from 'react';
import { Tree, Tooltip } from 'antd';
import classnames from 'classnames';
import { PREFIX_CLS } from "../constants/dictionary";
var prefixCls = "".concat(PREFIX_CLS, "-tree");
import "./style/index.less";
// 二次封装Tree，增加单选功能
var AntdTree = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$multiple = _ref.multiple,
    multiple = _ref$multiple === void 0 ? false : _ref$multiple,
    rootClassName = _ref.rootClassName,
    checkStrictly = _ref.checkStrictly,
    defaultCheckedKeys = _ref.defaultCheckedKeys,
    realOnCheck = _ref.onCheck,
    restProps = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(new Map()),
    _useState2 = _slicedToArray(_useState, 2),
    checkedKeysMap = _useState2[0],
    setCheckedKeysMap = _useState2[1];
  // 统一处理点击时的操作，主要是为了区分单选和多选时的处理
  var comCheckedHandle = function comCheckedHandle(info) {
    var node = info.node;
    var key = node.key;
    var hasChecked = checkedKeysMap.get(key);
    var temp = new Map(checkedKeysMap);
    // 判断当前是否单选，及当前节点是否选择，单选情况下二次点击不取消当前选择
    if (!multiple) {
      if (hasChecked) return temp;
      temp.clear();
      temp.set(key, node);
    } else {
      // 当前为多选时，判断是否已经选中，如果当前已经选中了，那么就取消选中，如果当前未选中，那么就将当前项添加至选中数组
      if (!hasChecked) {
        temp.set(key, node);
      } else {
        temp.delete(key);
      }
    }
    return temp;
  };

  // 选中的树节点list
  var checkedKeys = useMemo(function () {
    var tempKeys = defaultCheckedKeys || [];
    checkedKeysMap.forEach(function (_ref2) {
      var key = _ref2.key;
      if (key) {
        tempKeys = [key];
      }
    });
    return tempKeys;
  }, [checkedKeysMap]);
  var onCheck = function onCheck(_, __, checkedKeysMap) {
    checkedKeysMap && setCheckedKeysMap(checkedKeysMap);
  };
  var onTreeCheck = function onTreeCheck(_, info) {
    var tmepMap = comCheckedHandle(info);
    onCheck([], info, tmepMap);
    var tempCheckKeys = [];
    var _iterator = _createForOfIteratorHelper(tmepMap.keys()),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var i = _step.value;
        tempCheckKeys.push(i);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    realOnCheck && realOnCheck(tempCheckKeys, info, tmepMap);
  };
  return /*#__PURE__*/React.createElement(Tree, _extends({
    ref: ref,
    onCheck: onTreeCheck,
    rootClassName: classnames(prefixCls, _defineProperty({}, "".concat(prefixCls, "-radio"), !multiple), rootClassName)
  }, multiple ? {
    checkStrictly: checkStrictly
  } : {
    checkStrictly: true,
    checkedKeys: checkedKeys
  }, {
    titleRender: function titleRender(nodeData) {
      return /*#__PURE__*/React.createElement(Tooltip, {
        title: nodeData === null || nodeData === void 0 ? void 0 : nodeData.tip
      }, /*#__PURE__*/React.createElement("span", {
        key: nodeData.key
      }, nodeData === null || nodeData === void 0 ? void 0 : nodeData.title));
    },
    defaultCheckedKeys: defaultCheckedKeys
  }, restProps));
});
AntdTree.TreeNode = Tree.TreeNode;
AntdTree.DirectoryTree = Tree.DirectoryTree;
AntdTree.defaultProps = {
  multiple: true
};
export default AntdTree;