/// <reference types="react" />
import { Tree } from 'antd';
import type { TreeProps as AntdTreeProps, TreeDataNode as AntdTreeDataNode } from 'antd';
export interface TreeProps extends Omit<AntdTreeProps, 'onCheck'> {
    multiple?: boolean;
    onCheck?: (checkedKeysValue: React.Key[], info: any, checkedKeysMap?: Map<React.Key, TreeDataNode> | boolean) => void;
    [key: string]: any;
}
export interface TreeDataNode extends AntdTreeDataNode {
    tip?: string | number;
}
export interface CompoundedComponent extends React.ForwardRefExoticComponent<TreeProps & React.RefAttributes<any>> {
    TreeNode: typeof Tree.TreeNode;
    DirectoryTree: typeof Tree.DirectoryTree;
}
export type { DataNode } from 'antd/es/tree';
