function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { useRef, useMemo } from 'react';
import Button from "../Button";
import message from "../Message";
import Icon from "../Icon";
import classnames from 'classnames';
import { Tooltip, Typography } from 'antd';
import { PREFIX_CLS, primary_color } from "../constants/dictionary";
import "./style/copyDownload.less";
var Paragraph = Typography.Paragraph;
var prefixCls = "".concat(PREFIX_CLS, "-textDownload");
var TextCopyDownload = function TextCopyDownload(props) {
  var text = props.text,
    downloadBtnRender = props.downloadBtnRender,
    _props$btnText = props.btnText,
    btnText = _props$btnText === void 0 ? '下载' : _props$btnText,
    _props$fileName = props.fileName,
    fileName = _props$fileName === void 0 ? '文案.txt' : _props$fileName,
    iconType = props.iconType,
    className = props.className,
    showText = props.showText,
    _props$showTooltip = props.showTooltip,
    showTooltip = _props$showTooltip === void 0 ? true : _props$showTooltip,
    _props$textType = props.textType,
    textType = _props$textType === void 0 ? 'normal' : _props$textType,
    copyable = props.copyable;
  var ref = useRef(null);
  var copyDom = /*#__PURE__*/React.createElement("span", {
    style: {
      color: primary_color,
      fontWeight: 300
    }
  }, "\u590D\u5236");
  var data = useMemo(function () {
    var isBoolean = typeof copyable === 'boolean';
    return isBoolean && copyable ? {
      tooltips: false,
      icon: [copyDom, copyDom],
      text: text,
      onCopy: function onCopy() {
        return message.success('复制成功');
      }
    } : copyable;
  }, [copyable]);

  // 文案下载
  var textDownload = function textDownload() {
    var value = text || '';
    // 创建一个虚拟的a标签，设置下载属性
    var aTag = document.createElement('a');
    // 创建一个新的Blob对象
    var blob = new Blob([value], {
      type: 'text/plain'
    });
    // 生成一个临时的URL，用于下载
    var url = URL.createObjectURL(blob);
    aTag.download = fileName;
    aTag.href = url;
    // 将a标签添加到DOM中，模拟点击进行下载
    document.body.appendChild(aTag);
    aTag.click();
    // 清理
    document.body.removeChild(aTag);
    URL.revokeObjectURL(url);
  };

  // toolTip复制
  var tooltipContain = /*#__PURE__*/React.createElement(React.Fragment, null, text, /*#__PURE__*/React.createElement(Paragraph, {
    style: {
      display: 'flex',
      justifyContent: 'right',
      marginBottom: 0
    },
    copyable: data
  }));
  return /*#__PURE__*/React.createElement(Tooltip, {
    className: className,
    getPopupContainer: function getPopupContainer() {
      return ref && ref.current;
    },
    title: showTooltip && tooltipContain
  }, /*#__PURE__*/React.createElement("span", {
    ref: ref,
    className: classnames(_defineProperty({}, "".concat(prefixCls, "-tagText"), textType === 'tag'))
  }, iconType && /*#__PURE__*/React.createElement(Icon, {
    type: iconType,
    style: {
      marginRight: 2
    }
  }), showText || text), downloadBtnRender !== undefined ? downloadBtnRender : /*#__PURE__*/React.createElement(Button, {
    type: "link",
    onClick: textDownload,
    noPadding: true
  }, btnText));
};
export default TextCopyDownload;