import React, { ReactNode } from 'react';
import type { TypographyProps, TooltipProps } from 'antd';
export interface TextMore {
    text: string;
    rows?: number;
    more?: ReactNode[];
}
export interface Ellipsis {
    text: string;
    width: number;
    isMaxWidth?: boolean;
    hover?: boolean;
}
export interface LongTextProps {
    text: string;
    length?: number;
    tooltip?: string | number;
    getPopupContainer?: TooltipProps['getPopupContainer'];
    style?: React.CSSProperties;
}
export interface TextOverFlowProps {
    width?: number | string;
    style?: React.CSSProperties;
    className?: string;
    showTips?: boolean;
    maxWidth?: number;
}
export interface TextDownloadProps {
    text?: string;
    fileName?: string;
    btnText?: string;
    iconType?: string;
    className?: string;
    showText?: React.ReactNode;
    downloadBtnRender?: React.ReactNode;
    textType?: 'normal' | 'tag';
    showTooltip?: boolean;
    copyable?: {
        text: string;
        onCopy: (event?: React.MouseEvent<HTMLDivElement, MouseEvent> | undefined) => void;
        icon: ReactNode;
        tooltips: false | [ReactNode, ReactNode];
        format: 'text/plain' | 'text/html';
    } | boolean;
}
export interface RljTypographyProps extends TypographyProps {
    TextMore: React.FC<TextMore>;
    Ellipsis: React.FC<Ellipsis>;
    LongText: React.FC<LongTextProps>;
    TextOverFlow: React.FC<TextOverFlowProps>;
    TextDownload: React.FC<TextDownloadProps>;
}
